#!/usr/bin/env python
"""Module ldap"""
from pyeole.process import system_code
from pyeole.service import service_out
from glob import glob
from os import unlink, makedirs
from os.path import dirname, join, isdir
from pyeole.bacularestore import bacula_restore_one_file, exit_if_running_jobs
from creole.eosfunc import mode_conteneur
from shutil import copyfile

ldapfile = '/home/backup/sauv_ldap.ldif'

def execute(option, opt_str, value, parser, jobid, test_jobs=True):
    """ldap helper"""
    if len(parser.rargs) > 0:
        option = parser.rargs[0]
        if option == 'pre':
            pre()
        elif option == 'post':
            post()
    else:
        if test_jobs:
            exit_if_running_jobs()
        job(jobid)

def pre():
    print "pre ldap"

def post():
    print "post ldap"
    container = mode_conteneur()
    if container == 'oui':
        from creole.eosfunc import load_container_var
        container_conf = load_container_var()
        path = container_conf.get('container_path_annuaire', '')
        destdir = path + dirname(ldapfile)
        if not isdir(destdir):
            makedirs(destdir)
        copyfile(ldapfile, path + ldapfile)
    else:
        path = ''
    service_out('slapd', 'stop', 'annuaire')
    system_code(["sleep", "5"])
    for files in glob("{0}/var/lib/ldap/*.*".format(path)):
        unlink(files)
    system_code(["/usr/sbin/slapadd", "-f", "/etc/ldap/slapd.conf", "-l", ldapfile], container='annuaire')
    system_code(["chown", "-R", "openldap:openldap", "/var/lib/ldap"], container='annuaire')
    service_out('slapd', 'start', 'annuaire')

def job(jobid):
    print "Restauration de l'annuaire LDAP"
    bacula_restore_one_file(ldapfile, jobid)


priority=20
